#include "sgml2.h"
#include <stdlib.h>
#include <ctype.h>

#ifdef _HAS_SEARCH_H
#include <search.h>
#else
#include "search.h"
#endif

OPTION * optnew(char*name,char*val){
  OPTION* res=malloc(sizeof(OPTION));
  res->name[0]=res->value[0]=0;
  if(name) {
    strncpy(res->name,name,OPTLEN); res->name[OPTLEN-1]=0;
    stoupper(res->name);
  } 
  if(val) {
    strncpy(res->value,val,OPTVALLEN); res->value[OPTVALLEN-1]=0;
  } 
  return res;
}
OPTION * optset(OPTION*opt,char*val){
  if(!opt) return opt;
  opt->value[0]=0;
  if(val) {
    strncpy(opt->value,val,OPTVALLEN);
    opt->value[OPTVALLEN-1]=0;
  } 
  return opt;
}

OPTION * optsfind(OPTION**opts,char*name){
  OPTION * opt=*opts;
  if(!opt) return NULL;
  if(strcmp(opt->name,name)==0) return opt;
  return optsfind(&opt->next,name);
}
int optsfree(OPTION**opts){
  int n;
  OPTION*opt=*opts;
  if(!opt) return 0;
  n=optsfree(&opt->next);
  *opts=NULL;
  free(opt);
  return n+1;
}

/*--------------------------------------*/

MARK* mrknew(char*name){
  MARK *res=malloc(sizeof(MARK));
  res->name[0]=0;
  res->options=NULL;res->next=NULL;
  if(name) {
    strncpy(res->name,name,NAMELEN); res->name[NAMELEN-1]=0;
    stoupper(res->name);
  }
  return res;
}
void mrkfree(MARK*mark){
  optsfree(&mark->options);
  free(mark);
}
MARK* mrkaddopt(MARK*mark,OPTION*opt){
  if(!opt || !mark) return mark;
  opt->next=mark->options;
  mark->options=opt;
  return mark;
}

MARK* mrkspush(MARK**marks,MARK*mark){
  if(!mark) return NULL;
  mark->next=*marks;
  *marks=mark;
}
MARK* mrkspop(MARK**marks){
  MARK *res=*marks;
  *marks=res->next;
  res->next=NULL;
  return res;
}
