%{
#include "sgml2.h"
#ifdef _HAS_SEARCH_H
#include <search.h>
#else
#include "search.h"
#endif

#define yyerror mrkerror
#define yylex mrklex
#define yylval mrklval

int yyparse();
static yyerror(char*s);
static int yylex();

static int thePrintSem=0;
#define lockout   (++thePrintSem)
#define unlockout (--thePrintSem)
#define out(a) (thePrintSem==0 ? o(a),1:0)
#define outc(a) (thePrintSem==0 ? oc(a),1:0)

static ENTRY  * theDesc;
static OPTION * theOptions;
char buf[NAMELEN+1];
int bidx;
OPTION *opt;

%}
%token ANNY BSLASH DOLLAR PERCENT LPAR RPAR
%start desc
%%
desc : 
     | desc ANNY        {outc($2);}
     | desc BSLASH special {outc($3);}  
     | desc cond 
     | desc var
     ;

special : BSLASH | DOLLAR | PERCENT | LPAR | RPAR ;

letters : ANNY               { buf[0]=$1;bidx=1; }
        | letters ANNY       { buf[bidx++]=$2; }
        ;

var : DOLLAR varname { 
            buf[bidx]=0;
            opt=optsfind(&theOptions,buf);
	    if(opt && opt->value) out(opt->value);
	  }
    ;
cond : PERCENT letters LPAR 
          {
	    if(thePrintSem) {
	      lockout;
	    } else {
	      buf[bidx]=0;
	      opt=optsfind(&theOptions,buf);
	      if(!opt) lockout;
	    }
	  }
        desc RPAR { if(thePrintSem) unlockout; }
     ;

varname : ANNY         { buf[0]=$1; buf[bidx=1]=0; }
        | LPAR letters RPAR { buf[bidx]=0;}
        ;

%%
static char *inpbuffer;
char *lexinp;

static int theLine,theCol;

static int yylex() {
  if(!*lexinp) return 0;
  yylval=*lexinp++;
  theCol = yylval=='\n' ? ++theLine,0 : theCol+1;
  switch(yylval) {
  case '$': return DOLLAR; case '%': return PERCENT;
  case '(': return LPAR;   case ')': return RPAR;
  case '\\':return BSLASH;
  }
  return ANNY;
}

int mrkprint(MARK*mark){
  ENTRY what;
  if(!mark) return 0;
  theOptions=mark->options;
  what.key=mark->name;
  if((theDesc=hsearch(what,FIND))==NULL) return 1;
  lexinp=theDesc->data;
  theLine=theCol=1;
  return yyparse();
}

static yyerror(char*s) {
  fprintf(stderr,"parsing mark's %s description %s\nLine %d:%d: %s\n",
	  theDesc->key,theDesc->data,
	  theLine,theCol,s);
}
