#include "config.h"
#include <stdio.h>
#include <stdlib.h>

/* marking & option - handling */

#define NAMELEN 20
#define OPTLEN 20
#define OPTVALLEN 200

#define STREND "e"
#define STRBEG "b"

typedef struct __tagoption {
  char name[OPTLEN];
  char value[OPTVALLEN];
  struct __tagoption *next;
} OPTION;

extern OPTION * optnew(char*name,char*val);
extern OPTION * optset(OPTION*opt,char*val);

extern OPTION * optsfind(OPTION**opts,char*name);
extern int optsfree(OPTION**opts);

typedef struct __tagmark {
  char    name[NAMELEN];
  OPTION *options;
  struct __tagmark *next;
} MARK;

extern MARK * theMarks;

extern MARK* mrknew(char*name);
extern void mrkfree(MARK*mark);
extern MARK* mrkaddopt(MARK*mark,OPTION*opt);
extern int mrkprint(MARK*mark);

extern MARK* mrkspush(MARK**marks,MARK*mark);
extern MARK* mrkspop(MARK**mark);

/* configuration */

#define CLOSE1 '/'
#define CLOSE2 ';'

extern int trconf_init(FILE*in);

/* Character-conversion */

#define CHARCONVCHAR '&'
#define CHARCONVEND ';'

#define CHARCONVLEN 40
typedef struct __tagcharconv {
  char key[CHARCONVLEN];
  char *data;
  struct __tagcharconv *next;
} CHARCONV;

extern CHARCONV *theCharconvs;

extern int o(char*);

extern int sgmlparse();

/* Magik-input */
extern int cooking_lock(),cooking_unlock();

/* util */

char * stoupper(char *s);
