%{
#include "sgml2.h"

/* static yyparse(); */
int yyparse();

MARK * theMarks;

int bidx;
char buffer[200];
#define CLEARBUFFER  {buffer[bidx=0]=0;}
#define APPBUFFER(a) {if(bidx>=200) {fputs("Buffer overflow",stderr);\
		      CLOSEBUFFER;fputs(buffer,stderr);YYABORT;} \
                      buffer[bidx++]=(a);}
#define CLOSEBUFFER  {buffer[bidx]=0;}
#define SETBUFFER(a) {CLEARBUFFER;APPBUFFER(a);}

char mrkbuf[100];

%}
%token ALNUM WS MARKBEG MARKEND 
%token EXCLAIM DASH ENDMARK ASSIGN QUOTE
%start text

%%

text : 
     | text  character  {SETBUFFER($2);CLOSEBUFFER;o(buffer);}
     | text markup
     ;

markup : MARKBEG marking MARKEND ;

marking : EXCLAIM DASH DASH comment
        | {strcpy(mrkbuf,STRBEG);} markingrest         
        | ENDMARK {strcpy(mrkbuf,STREND);} markingrest 
        ;
markingrest :  {cooking_lock();} 
               mark {mrkspush(&theMarks,mrknew(strcat(mrkbuf,buffer)));}
               options 
               {cooking_unlock();mrkprint(theMarks);};

mark : word {CLOSEBUFFER;} ;

options : /*e*/
        | options gap option
        ;

option : word {CLOSEBUFFER;mrkaddopt(theMarks,optnew(buffer,NULL));}
         ASSIGN 
         optionvalue {CLOSEBUFFER;optset(theMarks->options,buffer);}
       ;
optionvalue : word | string ;

word : ALNUM      {SETBUFFER($1);}
     | word ALNUM {APPBUFFER($2);}
     ;

string : QUOTE {CLEARBUFFER;} stringchars QUOTE {CLOSEBUFFER;};
stringchars : /*e*/ 
            | stringchars stringchar {APPBUFFER($2);}
            ;

comment : /*e*/ | comment character ;

stringchar : WS | ALNUM | specialchar | markchar;
character : WS | ALNUM | QUOTE | specialchar;
specialchar : ENDMARK | ASSIGN | EXCLAIM | DASH;
markchar : MARKBEG | MARKEND ;

cgap : /*e*/ | gap;
gap : WS | gap WS;


%%

static int theLine,theCol;

int yylex() {
  yylval=getcc(stdin);
  theCol = yylval=='\n' ? ++theLine,1 : theCol+1;
  switch(yylval) {
  case EOF: return 0;
  case '<': return MARKBEG;
  case '>': return MARKEND;
  case '/': return ENDMARK;
  case '=': return ASSIGN;
  case '"': return QUOTE;
  case '!': return EXCLAIM;
  case '-': return DASH;
  default: if(yylval>32) return ALNUM; else return WS;
  }
}

static yyerror(char * s) {
  fprintf(stderr,":%d:%d: %s\n",theLine,theCol,s);
}

int sgmlparse() {
  theLine=theCol=1;
  while(!feof(stdin)) {
    theMarks=NULL;
    if(yyparse()) exit(1);
    flusho();
    while(theMarks) mrkfree(mrkspop(&theMarks));
  }
 return 0;
}
