#include "sgml2.h"
#ifdef _HAS_SEARCH_H
#include <search.h>
#else
#include "search.h"
#endif
#include <strings.h>

char * stoupper(char*s) {
  for(;*s ; ++s) *s=toupper(*s);
  return s;
}

char * fgetln(char * s, int n, FILE * f){
  do {
    *s=0;
    if(feof(f)) return NULL;
    fgets(s,n,f);
  } while(*s=='#');
  return s;
}

CHARCONV* addcconf(char*s) {
  /* &x*;conf'\n' -> x*'\0'conf'\0' */
  CHARCONV* res=malloc(sizeof(CHARCONV));
  int sl=strlen(++s);  /* & weg */
  if(!res) return NULL;
  sl = sl>CHARCONVLEN ? CHARCONVLEN-1 : sl-1 ;  /* chop '\n' */
  s[sl]=0;
  strcpy(res->key,s);
  res->data=index(res->key,CHARCONVEND);
  if(res->data) *res->data++=0;
  res->next=theCharconvs;
  return theCharconvs=res;
}

addmrkdef(char*mark,char*val) {
  ENTRY entry;
  char *p;
  int ml=strlen(mark),vl=strlen(val);
  p=malloc(ml+vl+2);
  entry.key=p;
  entry.data=p+ml+1;
  strcpy(entry.key,mark);
  stoupper(entry.key);
  strcpy(entry.data,val);
#ifdef ALLONEDEBUG
  printf("key: >>%s<< data:\n%s\n****\n",entry.key,entry.data);
#endif
  hsearch(entry,ENTER);
}

int rdconf(FILE * f){
  int nmark=0;
  int state=0,nxstate;
  int i;
  char buf[2000],nb[2][NAMELEN+1],*inp,*stop;
  strcpy(nb[0],STRBEG);
  strcpy(nb[1],STREND);
  inp=buf;
  while(1) {
    if(!fgetln(inp,sizeof(buf)-(inp-buf),f)&&(state==0 ||state==2)) 
      return nmark;
    if(*inp==CHARCONVCHAR) { addcconf(inp); continue;}
    initial:
    switch(state) {
    case 0:        /* Marke ab Zeilenbeginn nach nb[x] */
      if(!isalnum(*inp)) continue;
      for(i=0;isalnum(inp[i]) && i<NAMELEN;++i) 
	nb[0][i+sizeof(STRBEG)-1]=nb[1][i+sizeof(STREND)-1]=buf[i];
      nb[0][i+sizeof(STRBEG)-1]=nb[1][i+sizeof(STREND)-1]=0;
      stop=buf;
      state=1; break;
    case 1: case 2:
      if(*inp==CLOSE1 && state==1) {
	nxstate=2;
      } else if(*inp==CLOSE2) {
	nxstate=0;
      } else {
	strcpy(inp,inp+1); inp+=strlen(inp);
	stop=inp-1;
	continue;
      }
      if(stop>buf) {  
	*stop=0;
	addmrkdef(nb[state-1],buf);
	++nmark;
      }
      state=nxstate;
      inp=buf;
      break;
    }
  }
  return nmark;
}


/*-------*/

int trconf_init(FILE * in) {
  if(!in) return 1;
  hcreate(50);
  rdconf(in);
  return 1;
}

int trconf_destr() {
  hdestroy();
  return 1;
}

#ifdef ALLONEDEBUG
CHARCONV * theCharconvs;
main(int argc,char **argv){
 trconf_init(argv[1]);
}
#endif
